package com.contactology;

import com.contactology.SurveyTown;

public class SurveyTown_Admin extends SurveyTown {
        public SurveyTown_Admin( String key ) {
                super( key );
        }

                        
	                
	/**
	 * Create a new SurveyTown account with the given parameters
	 *
	 * 
	 *
	 	 * @param String clientName Name for the account
	 * @param String adminEmail Default email address for the account
	 * @param String userName User name for the new account - must be unique and no more than 64 characters
	 * @param String password Password for the new account
	 * @param HashMap<String, String> optionalParameters A struct of optional parameters, see below for valid keys
	 * @return Object The user ID of the new account
	 */ 
	public Object Admin_Create_Account( String clientName, String adminEmail, String userName, String password, HashMap<String, String> optionalParameters ) {
		Object data;
		List <BasicNameValuePair> args = new ArrayList <BasicNameValuePair>();
		args = this.makeArg( args, "method", "Admin_Create_Account" );
		args = this.makeArg( args, "clientName", clientName );
		args = this.makeArg( args, "adminEmail", adminEmail );
		args = this.makeArg( args, "userName", userName );
		args = this.makeArg( args, "password", password );
		args = this.makeArg( args, "optionalParameters", optionalParameters );

		data = this.makeCall( args );
    
		return data;
	}
                    
	                
	/**
	 * Get a list of your current clients
	 *
	 * 
	 *
	 	 * @return Object Struct of current client accounts { clientId : clientName, clientId : clientName }
	 */ 
	public Object Admin_Get_Accounts(  ) {
		Object data;
		List <BasicNameValuePair> args = new ArrayList <BasicNameValuePair>();
		args = this.makeArg( args, "method", "Admin_Get_Accounts" );

		data = this.makeCall( args );
    
		return data;
	}
                    
	                
	/**
	 * Get a list of your clients based on parameters
	 *
	 * 
	 *
	 	 * @param HashMap<String, String> optionalParameters A struct of optional parameters, see below for valid keys
	 * @return Object Struct of accounts { { "clientId":"1", "clientStatus":"active", "clientCreated":"2012-01-01 00:00:00" }, { "clientId":"2", "clientStatus":"disabled", "clientCreated":"2012-02-02 02:00:00" }
	 */ 
	public Object Admin_Find_Accounts( HashMap<String, String> optionalParameters ) {
		Object data;
		List <BasicNameValuePair> args = new ArrayList <BasicNameValuePair>();
		args = this.makeArg( args, "method", "Admin_Find_Accounts" );
		args = this.makeArg( args, "optionalParameters", optionalParameters );

		data = this.makeCall( args );
    
		return data;
	}
                    
	                
	/**
	 * Modify an existing SurveyTown account with the given parameters
	 *
	 * 
	 *
	 	 * @param  clientId The client ID number you want to modify
	 * @param HashMap<String, String> optionalParameters A struct of optional parameters, see below for valid keys
	 * @return Object The number of fields successfully modified
	 */ 
	public Object Admin_Update_Account( int clientId, HashMap<String, String> optionalParameters ) {
		Object data;
		List <BasicNameValuePair> args = new ArrayList <BasicNameValuePair>();
		args = this.makeArg( args, "method", "Admin_Update_Account" );
		args = this.makeArg( args, "clientId", clientId );
		args = this.makeArg( args, "optionalParameters", optionalParameters );

		data = this.makeCall( args );
    
		return data;
	}
                    
	                
	/**
	 * Suspend an Account you created
	 *
	 * 
	 *
	 	 * @param  clientId The client ID number you want to modify
	 * @return Object true on success
	 */ 
	public Object Admin_Suspend_Account( int clientId ) {
		Object data;
		List <BasicNameValuePair> args = new ArrayList <BasicNameValuePair>();
		args = this.makeArg( args, "method", "Admin_Suspend_Account" );
		args = this.makeArg( args, "clientId", clientId );

		data = this.makeCall( args );
    
		return data;
	}
                    
	                
	/**
	 * Reinstate an Account you suspended
	 *
	 * 
	 *
	 	 * @param  clientId The client ID number you want to modify
	 * @return Object true on success
	 */ 
	public Object Admin_Reinstate_Account( int clientId ) {
		Object data;
		List <BasicNameValuePair> args = new ArrayList <BasicNameValuePair>();
		args = this.makeArg( args, "method", "Admin_Reinstate_Account" );
		args = this.makeArg( args, "clientId", clientId );

		data = this.makeCall( args );
    
		return data;
	}
                    
	                
	/**
	 * Creates an API key for the specified account.
	 *
	 * 
	 *
	 	 * @param  clientId The account ID number for which you want the API key
	 * @param HashMap<String, String> optionalParameters A struct of optional parameters, see below for valid keys
	 * @return Object API Key
	 */ 
	public Object Admin_Create_Account_Key( int clientId, HashMap<String, String> optionalParameters ) {
		Object data;
		List <BasicNameValuePair> args = new ArrayList <BasicNameValuePair>();
		args = this.makeArg( args, "method", "Admin_Create_Account_Key" );
		args = this.makeArg( args, "clientId", clientId );
		args = this.makeArg( args, "optionalParameters", optionalParameters );

		data = this.makeCall( args );
    
		return data;
	}
                    
	                
	/**
	 * Return the API key for an account, or create one if one doesn't already exist and the username is not specified.
	 *
	 * 
	 *
	 	 * @param  clientId The account ID number for which you want the API key
	 * @param HashMap<String, String> optionalParameters A struct of optional parameters, see below for valid keys
	 * @return Object API Key
	 */ 
	public Object Admin_Get_Account_Key( int clientId, HashMap<String, String> optionalParameters ) {
		Object data;
		List <BasicNameValuePair> args = new ArrayList <BasicNameValuePair>();
		args = this.makeArg( args, "method", "Admin_Get_Account_Key" );
		args = this.makeArg( args, "clientId", clientId );
		args = this.makeArg( args, "optionalParameters", optionalParameters );

		data = this.makeCall( args );
    
		return data;
	}
                    
	                
	/**
	 * Send an Alert Message to a set of your clients
	 *
	 * 
	 *
	 	 * @param ArrayList<?> clientIds An array of Client IDs who will receive the message
	 * @param String shortMessage A short message, up to 255 characters
	 * @param HashMap<String, String> optionalParameters A struct of optional parameters, see below for valid keys
	 */ 
	public Object Admin_Send_Message( ArrayList<?> clientIds, String shortMessage, HashMap<String, String> optionalParameters ) {
		Object data;
		List <BasicNameValuePair> args = new ArrayList <BasicNameValuePair>();
		args = this.makeArg( args, "method", "Admin_Send_Message" );
		args = this.makeArg( args, "clientIds", clientIds );
		args = this.makeArg( args, "shortMessage", shortMessage );
		args = this.makeArg( args, "optionalParameters", optionalParameters );

		data = this.makeCall( args );
    
		return data;
	}
                    
	                
	/**
	 * Get the current Webhooks settings for the specified Account
	 *
	 * 
	 *
	 	 * @param  clientId The client ID number you want to modify
	 * @return Object A struct of Webhook data
	 */ 
	public Object Admin_Get_Account_Webhooks( int clientId ) {
		Object data;
		List <BasicNameValuePair> args = new ArrayList <BasicNameValuePair>();
		args = this.makeArg( args, "method", "Admin_Get_Account_Webhooks" );
		args = this.makeArg( args, "clientId", clientId );

		data = this.makeCall( args );
    
		return data;
	}
                    
	                
	/**
	 * Admin_Set_Account_Webhooks allows you to set the Webhooks information for the specified Account
	 *
	 * The Account's current settings will be overriden, so specify all the hooks and locations you want
	 * 
	 * Note: To receive WEBHOOK_BOUNCED or WEBHOOK_CAMPAIGN_CLICKED, you must have the System location active
	 *
	 	 * @param  clientId The client ID number you want to modify
	 * @param String url The URL to receive the Webhook
	 * @param String webhooksKey webhookKey The Webhook Key passed along with the data to verify the origin, this is important for security
	 * @param ArrayList<?> hooks An array of events you would like to receive Webfor. Valid values are: WEBHOOK_SUBSCRIBE, WEBHOOK_UNSUBSCRIBE, WEBHOOK_GLOBAL_UNSUBSCRIBE, WEBHOOK_PROFILE_UPDATE, WEBHOOK_BOUNCED, WEBHOOK_EMAIL_CHANGED, WEBHOOK_CAMPAIGN_OPENED, WEBHOOK_CAMPAIGN_CLICKED, WEBHOOK_CAMPAIGN_SHARED, WEBHOOK_CAMPAIGN_SENDING_STARTED, WEBHOOK_CAMPAIGN_SENT, WEBHOOK_CAMPAIGN_SENT_TO_ADDITIONAL_RECIPIENT, WEBHOOK_REACTIVATED, WEBHOOK_LIST_CREATED, WEBHOOK_LIST_DELETED, WEBHOOK_LIST_CHANGED
	 * @param ArrayList<?> locations An array of Locations a particular Hook can be fired from. Valid values are: ContactDirect, Webapp, WebappBulk, System, API
	 * @param ArrayList<?> customFieldIds An array of Custom Field IDs (See: Custom_Field_Get_All) - if specified, the values of the specified fields will be included in the data payload for any Webhook sending contact data
	 * @param ArrayList<?> optionalParameters optionalParameters
	 * @return Object A struct of Webhook data
	 */ 
	public Object Admin_Set_Account_Webhooks( int clientId, String url, String webhooksKey, ArrayList<?> hooks, ArrayList<?> locations, ArrayList<?> customFieldIds, ArrayList<?> optionalParameters ) {
		Object data;
		List <BasicNameValuePair> args = new ArrayList <BasicNameValuePair>();
		args = this.makeArg( args, "method", "Admin_Set_Account_Webhooks" );
		args = this.makeArg( args, "clientId", clientId );
		args = this.makeArg( args, "url", url );
		args = this.makeArg( args, "webhooksKey", webhooksKey );
		args = this.makeArg( args, "hooks", hooks );
		args = this.makeArg( args, "locations", locations );
		args = this.makeArg( args, "customFieldIds", customFieldIds );
		args = this.makeArg( args, "optionalParameters", optionalParameters );

		data = this.makeCall( args );
    
		return data;
	}
                    
	                
	/**
	 * Deactivate all Webhooks for an account
	 *
	 * Note: Webhooks already queued for sending will still be sent
	 *
	 	 * @param  clientId The client ID number you want to modify
	 * @return Object True on success
	 */ 
	public Object Admin_Deactivate_Account_Webhooks( int clientId ) {
		Object data;
		List <BasicNameValuePair> args = new ArrayList <BasicNameValuePair>();
		args = this.makeArg( args, "method", "Admin_Deactivate_Account_Webhooks" );
		args = this.makeArg( args, "clientId", clientId );

		data = this.makeCall( args );
    
		return data;
	}
    
}