require 'net/http'
require 'net/https'
require 'rubygems'
require 'json'

class SurveyTown
	def initialize( key )
		@key = key
		@api_url = "https://api.myfeedback.io/2/REST/"
		@version = "2.5.0"
	end
	
			
	def Integration_Get_Cookie( clientId, username, time = nil )
		args = {'key' => @key, 'method' => 'Integration_Get_Cookie'}
		args['clientId'] = clientId
		args['username'] = username
		args['time'] = time

		data = self.makeCall( args )
		
		return data
	end		
	def Integration_Login_Get_Cookie( username, password, time = nil )
		args = {'key' => @key, 'method' => 'Integration_Login_Get_Cookie'}
		args['username'] = username
		args['password'] = password
		args['time'] = time

		data = self.makeCall( args )
		
		return data
	end		
	def Contact_Get( email, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'Contact_Get'}
		args['email'] = email
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
		
		return data
	end		
	def Contact_Update( email, customFields, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'Contact_Update'}
		args['email'] = email
		args['customFields'] = customFields
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
		
		return data
	end		
	def Contact_Change_Email( email, newEmail )
		args = {'key' => @key, 'method' => 'Contact_Change_Email'}
		args['email'] = email
		args['newEmail'] = newEmail

		data = self.makeCall( args )
		
		return data
	end		
	def Contact_Activate( email )
		args = {'key' => @key, 'method' => 'Contact_Activate'}
		args['email'] = email

		data = self.makeCall( args )
		
		return data
	end		
	def Contact_Delete( email )
		args = {'key' => @key, 'method' => 'Contact_Delete'}
		args['email'] = email

		data = self.makeCall( args )
		
		return data
	end		
	def Contact_Suppress( email, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'Contact_Suppress'}
		args['email'] = email
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
		
		return data
	end		
	def Contact_Get_Person_Code( email )
		args = {'key' => @key, 'method' => 'Contact_Get_Person_Code'}
		args['email'] = email

		data = self.makeCall( args )
		
		return data
	end		
	def CustomField_Add_Textbox( fieldName, required, subscriberCanEdit, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'CustomField_Add_Textbox'}
		args['fieldName'] = fieldName
		args['required'] = required
		args['subscriberCanEdit'] = subscriberCanEdit
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
		
		return data
	end		
	def CustomField_Add_TextArea( fieldName, required, subscriberCanEdit, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'CustomField_Add_TextArea'}
		args['fieldName'] = fieldName
		args['required'] = required
		args['subscriberCanEdit'] = subscriberCanEdit
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
		
		return data
	end		
	def CustomField_Add_Password( fieldName, required, subscriberCanEdit, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'CustomField_Add_Password'}
		args['fieldName'] = fieldName
		args['required'] = required
		args['subscriberCanEdit'] = subscriberCanEdit
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
		
		return data
	end		
	def CustomField_Add_Decimal( fieldName, required, subscriberCanEdit, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'CustomField_Add_Decimal'}
		args['fieldName'] = fieldName
		args['required'] = required
		args['subscriberCanEdit'] = subscriberCanEdit
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
		
		return data
	end		
	def CustomField_Add_Currency( fieldName, required, subscriberCanEdit, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'CustomField_Add_Currency'}
		args['fieldName'] = fieldName
		args['required'] = required
		args['subscriberCanEdit'] = subscriberCanEdit
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
		
		return data
	end		
	def CustomField_Add_Integer( fieldName, required, subscriberCanEdit, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'CustomField_Add_Integer'}
		args['fieldName'] = fieldName
		args['required'] = required
		args['subscriberCanEdit'] = subscriberCanEdit
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
		
		return data
	end		
	def CustomField_Add_Dropdown( fieldName, required, subscriberCanEdit, options, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'CustomField_Add_Dropdown'}
		args['fieldName'] = fieldName
		args['required'] = required
		args['subscriberCanEdit'] = subscriberCanEdit
		args['options'] = options
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
		
		return data
	end		
	def CustomField_Add_Radio( fieldName, required, subscriberCanEdit, options, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'CustomField_Add_Radio'}
		args['fieldName'] = fieldName
		args['required'] = required
		args['subscriberCanEdit'] = subscriberCanEdit
		args['options'] = options
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
		
		return data
	end		
	def CustomField_Add_Checkbox( fieldName, required, subscriberCanEdit, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'CustomField_Add_Checkbox'}
		args['fieldName'] = fieldName
		args['required'] = required
		args['subscriberCanEdit'] = subscriberCanEdit
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
		
		return data
	end		
	def CustomField_Add_CheckboxList( fieldName, required, subscriberCanEdit, options, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'CustomField_Add_CheckboxList'}
		args['fieldName'] = fieldName
		args['required'] = required
		args['subscriberCanEdit'] = subscriberCanEdit
		args['options'] = options
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
		
		return data
	end		
	def CustomField_Add_Date( fieldName, required, subscriberCanEdit, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'CustomField_Add_Date'}
		args['fieldName'] = fieldName
		args['required'] = required
		args['subscriberCanEdit'] = subscriberCanEdit
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
		
		return data
	end		
	def CustomField_Add_Email( fieldName, required, subscriberCanEdit, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'CustomField_Add_Email'}
		args['fieldName'] = fieldName
		args['required'] = required
		args['subscriberCanEdit'] = subscriberCanEdit
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
		
		return data
	end		
	def CustomField_Add_Phone( fieldName, required, subscriberCanEdit, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'CustomField_Add_Phone'}
		args['fieldName'] = fieldName
		args['required'] = required
		args['subscriberCanEdit'] = subscriberCanEdit
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
		
		return data
	end		
	def CustomField_Add_StateDropdown( fieldName, required, subscriberCanEdit, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'CustomField_Add_StateDropdown'}
		args['fieldName'] = fieldName
		args['required'] = required
		args['subscriberCanEdit'] = subscriberCanEdit
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
		
		return data
	end		
	def CustomField_Add_Address( fieldName, required, subscriberCanEdit, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'CustomField_Add_Address'}
		args['fieldName'] = fieldName
		args['required'] = required
		args['subscriberCanEdit'] = subscriberCanEdit
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
		
		return data
	end		
	def CustomField_Find( searchParameters = {} )
		args = {'key' => @key, 'method' => 'CustomField_Find'}
		args['searchParameters'] = searchParameters

		data = self.makeCall( args )
		
		return data
	end		
	def CustomField_Get_All(  )
		args = {'key' => @key, 'method' => 'CustomField_Get_All'}

		data = self.makeCall( args )
		
		return data
	end		
	def CustomField_Update( fieldId, updateParameters )
		args = {'key' => @key, 'method' => 'CustomField_Update'}
		args['fieldId'] = fieldId
		args['updateParameters'] = updateParameters

		data = self.makeCall( args )
		
		return data
	end		
	def CustomField_Reorder( reorder )
		args = {'key' => @key, 'method' => 'CustomField_Reorder'}
		args['reorder'] = reorder

		data = self.makeCall( args )
		
		return data
	end		
	def CustomField_Delete( fieldId )
		args = {'key' => @key, 'method' => 'CustomField_Delete'}
		args['fieldId'] = fieldId

		data = self.makeCall( args )
		
		return data
	end		
	def Response_Get( surveyId, responseId )
		args = {'key' => @key, 'method' => 'Response_Get'}
		args['surveyId'] = surveyId
		args['responseId'] = responseId

		data = self.makeCall( args )
		
		return data
	end		
	def Response_Create( surveyId, updateParameters, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'Response_Create'}
		args['surveyId'] = surveyId
		args['updateParameters'] = updateParameters
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
		
		return data
	end		
	def Response_Update( surveyId, responseId, updateParameters, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'Response_Update'}
		args['surveyId'] = surveyId
		args['responseId'] = responseId
		args['updateParameters'] = updateParameters
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
		
		return data
	end		
	def Response_Delete( surveyId, responseId )
		args = {'key' => @key, 'method' => 'Response_Delete'}
		args['surveyId'] = surveyId
		args['responseId'] = responseId

		data = self.makeCall( args )
		
		return data
	end		
	def Survey_Start( surveyId )
		args = {'key' => @key, 'method' => 'Survey_Start'}
		args['surveyId'] = surveyId

		data = self.makeCall( args )
		
		return data
	end		
	def Survey_Stop( surveyId )
		args = {'key' => @key, 'method' => 'Survey_Stop'}
		args['surveyId'] = surveyId

		data = self.makeCall( args )
		
		return data
	end		
	def Survey_Copy( surveyId )
		args = {'key' => @key, 'method' => 'Survey_Copy'}
		args['surveyId'] = surveyId

		data = self.makeCall( args )
		
		return data
	end		
	def Survey_Delete( surveyId )
		args = {'key' => @key, 'method' => 'Survey_Delete'}
		args['surveyId'] = surveyId

		data = self.makeCall( args )
		
		return data
	end		
	def Survey_List(  )
		args = {'key' => @key, 'method' => 'Survey_List'}

		data = self.makeCall( args )
		
		return data
	end		
	def Survey_Find( optionalParameters = {} )
		args = {'key' => @key, 'method' => 'Survey_Find'}
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
		
		return data
	end		
	def Survey_Get_Info( surveyId )
		args = {'key' => @key, 'method' => 'Survey_Get_Info'}
		args['surveyId'] = surveyId

		data = self.makeCall( args )
		
		return data
	end		
	def Survey_Get_Questions( surveyId )
		args = {'key' => @key, 'method' => 'Survey_Get_Questions'}
		args['surveyId'] = surveyId

		data = self.makeCall( args )
		
		return data
	end		
	def Survey_Get_Response_Count( surveyId )
		args = {'key' => @key, 'method' => 'Survey_Get_Response_Count'}
		args['surveyId'] = surveyId

		data = self.makeCall( args )
		
		return data
	end		
	def Survey_Get_Responses_By_Email( emailAddress, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'Survey_Get_Responses_By_Email'}
		args['emailAddress'] = emailAddress
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
		
		return data
	end		
	def Survey_Get_Responses( surveyId, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'Survey_Get_Responses'}
		args['surveyId'] = surveyId
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
		
		return data
	end		
	def Survey_Get_Responses_Zapier(  )
		args = {'key' => @key, 'method' => 'Survey_Get_Responses_Zapier'}

		data = self.makeCall( args )
		
		return data
	end		
	def Survey_Add_Tag( surveyId, tagId )
		args = {'key' => @key, 'method' => 'Survey_Add_Tag'}
		args['surveyId'] = surveyId
		args['tagId'] = tagId

		data = self.makeCall( args )
		
		return data
	end		
	def Survey_Remove_Tag( surveyId, tagId )
		args = {'key' => @key, 'method' => 'Survey_Remove_Tag'}
		args['surveyId'] = surveyId
		args['tagId'] = tagId

		data = self.makeCall( args )
		
		return data
	end		
	def Tag_Create( name )
		args = {'key' => @key, 'method' => 'Tag_Create'}
		args['name'] = name

		data = self.makeCall( args )
		
		return data
	end		
	def Tag_Update( tagId, updateParameters )
		args = {'key' => @key, 'method' => 'Tag_Update'}
		args['tagId'] = tagId
		args['updateParameters'] = updateParameters

		data = self.makeCall( args )
		
		return data
	end		
	def Tag_Delete( tagId )
		args = {'key' => @key, 'method' => 'Tag_Delete'}
		args['tagId'] = tagId

		data = self.makeCall( args )
		
		return data
	end		
	def Tag_List( optionalParameters = {} )
		args = {'key' => @key, 'method' => 'Tag_List'}
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
		
		return data
	end		
	def EmailMessage_Create( surveyId, subject, content, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'EmailMessage_Create'}
		args['surveyId'] = surveyId
		args['subject'] = subject
		args['content'] = content
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
		
		return data
	end		
	def EmailMessage_Update( emailId, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'EmailMessage_Update'}
		args['emailId'] = emailId
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
		
		return data
	end		
	def EmailMessage_Test( emailId, contacts, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'EmailMessage_Test'}
		args['emailId'] = emailId
		args['contacts'] = contacts
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
		
		return data
	end		
	def EmailMessage_Delete( emailId )
		args = {'key' => @key, 'method' => 'EmailMessage_Delete'}
		args['emailId'] = emailId

		data = self.makeCall( args )
		
		return data
	end		
	def EmailMessage_Subscribe( emailId, contacts, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'EmailMessage_Subscribe'}
		args['emailId'] = emailId
		args['contacts'] = contacts
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
		
		return data
	end		
	def EmailMessage_Send( emailId, contacts, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'EmailMessage_Send'}
		args['emailId'] = emailId
		args['contacts'] = contacts
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
		
		return data
	end		
	def EmailMessage_Unsubscribe( emailId, emails )
		args = {'key' => @key, 'method' => 'EmailMessage_Unsubscribe'}
		args['emailId'] = emailId
		args['emails'] = emails

		data = self.makeCall( args )
		
		return data
	end		
	def EmailMessage_Find( surveyId, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'EmailMessage_Find'}
		args['surveyId'] = surveyId
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
		
		return data
	end
	
	def flattenArray( name, arg )
        out = {}
        arg.length.times do |i|
            if arg[i].kind_of?( Hash )
                m = self.flattenHash( name+"[#{i}]", arg[i] )
                out.merge!(m)
            elsif arg[i].kind_of?( Array )
                m = self.flattenArray( name+"[#{i}]", arg[i] )
                out.merge!(m)
            else
                out[name+"[#{i}]"] = arg[i]
            end
        end

        return out
    end

    def flattenHash( name, arg )
        out = {}
        arg.each { |key, value|
            if value.kind_of?( Hash )
                m = self.flattenHash( name+"[#{key}]", value )
                out.merge!(m)
            elsif value.kind_of?( Array )
                m = self.flattenArray( name+"[#{key}]", value )
                out.merge!(m)
            else
                out[name+"["+key+"]"] = value
            end
        }

        return out
    end

	def flattenArgs( args )
		new_args = args.dup
		args.each { |key, value|
			if value.kind_of?( Hash )
				m = self.flattenHash( key, value )
				new_args.delete( key )
				new_args.merge!(m)
			elsif value.kind_of?( Array )
				m = self.flattenArray( key, value )
				new_args.delete( key )
				new_args.merge!(m)
			end
		}
		return new_args
    end

    def is_a_number?(s)
        return s.to_s.match(/\A[+-]?\d+?(\.\d+)?\Z/) == nil ? false : true
    end
	
	def makeCall( args )
        uri = URI.parse( @api_url )
        args = self.flattenArgs( args )
        http = Net::HTTP.new( uri.host, uri.port )
		http.use_ssl = true
		http.verify_mode = OpenSSL::SSL::VERIFY_NONE
		
		request = Net::HTTP::Post.new( uri.request_uri )
		request.set_form_data( args )
		
		res = http.request( request )
		r = res.body.gsub(/"/, '')
        if self.is_a_number?(r)
			out = r.to_i
		elsif %w(true false).include?(res.body.to_s)
			out = res.body == "true"
		else
			unless res.body =~ /^\{.*\}$/
			r = "{\"value\":#{res.body}}"
			else
			r = res.body
			end
			
			out = JSON.parse r
			if ( ! out.kind_of?( Hash ) )
				return {} #Could not fetch API data
			end
			
			if ( out["result"] && out["result"] == "error" )
				raise "API Error: "+out["message"]+" ("+out["code"].to_s+")"
			end
		end
		return out
    end
end
		
class SurveyTownReseller < SurveyTown
	
end