require 'net/http'
require 'rubygems'
require 'json'

class SurveyTown
	def initialize( key )
		@key = key
		@api_url = "http://api.myfeedback.io/2/REST/"
		@version = "2.5.0"
	end
	
	                
	def Integration_Get_Cookie( clientId, username, time = nil )
		args = {'key' => @key, 'method' => 'Integration_Get_Cookie'}
		args['clientId'] = clientId
		args['username'] = username
		args['time'] = time

		data = self.makeCall( args )
	    
		return data
	end                
	def Integration_Login_Get_Cookie( username, password, time = nil )
		args = {'key' => @key, 'method' => 'Integration_Login_Get_Cookie'}
		args['username'] = username
		args['password'] = password
		args['time'] = time

		data = self.makeCall( args )
	    
		return data
	end                
	def Response_Get( surveyId, responseId )
		args = {'key' => @key, 'method' => 'Response_Get'}
		args['surveyId'] = surveyId
		args['responseId'] = responseId

		data = self.makeCall( args )
	    
		return data
	end                
	def Response_Create( surveyId, updateParameters, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'Response_Create'}
		args['surveyId'] = surveyId
		args['updateParameters'] = updateParameters
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
	    
		return data
	end                
	def Response_Update( surveyId, responseId, updateParameters, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'Response_Update'}
		args['surveyId'] = surveyId
		args['responseId'] = responseId
		args['updateParameters'] = updateParameters
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
	    
		return data
	end                
	def Response_Delete( surveyId, responseId )
		args = {'key' => @key, 'method' => 'Response_Delete'}
		args['surveyId'] = surveyId
		args['responseId'] = responseId

		data = self.makeCall( args )
	    
		return data
	end                
	def Survey_Start( surveyId )
		args = {'key' => @key, 'method' => 'Survey_Start'}
		args['surveyId'] = surveyId

		data = self.makeCall( args )
	    
		return data
	end                
	def Survey_Stop( surveyId )
		args = {'key' => @key, 'method' => 'Survey_Stop'}
		args['surveyId'] = surveyId

		data = self.makeCall( args )
	    
		return data
	end                
	def Survey_Copy( surveyId )
		args = {'key' => @key, 'method' => 'Survey_Copy'}
		args['surveyId'] = surveyId

		data = self.makeCall( args )
	    
		return data
	end                
	def Survey_Delete( surveyId )
		args = {'key' => @key, 'method' => 'Survey_Delete'}
		args['surveyId'] = surveyId

		data = self.makeCall( args )
	    
		return data
	end                
	def Survey_List(  )
		args = {'key' => @key, 'method' => 'Survey_List'}

		data = self.makeCall( args )
	    
		return data
	end                
	def Survey_Find( optionalParameters = {} )
		args = {'key' => @key, 'method' => 'Survey_Find'}
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
	    
		return data
	end                
	def Survey_Get_Info( surveyId )
		args = {'key' => @key, 'method' => 'Survey_Get_Info'}
		args['surveyId'] = surveyId

		data = self.makeCall( args )
	    
		return data
	end                
	def Survey_Get_Questions( surveyId )
		args = {'key' => @key, 'method' => 'Survey_Get_Questions'}
		args['surveyId'] = surveyId

		data = self.makeCall( args )
	    
		return data
	end                
	def Survey_Get_Response_Count( surveyId )
		args = {'key' => @key, 'method' => 'Survey_Get_Response_Count'}
		args['surveyId'] = surveyId

		data = self.makeCall( args )
	    
		return data
	end                
	def Survey_Get_Responses_By_Email( emailAddress, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'Survey_Get_Responses_By_Email'}
		args['emailAddress'] = emailAddress
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
	    
		return data
	end                
	def Survey_Get_Responses( surveyId, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'Survey_Get_Responses'}
		args['surveyId'] = surveyId
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
	    
		return data
	end                
	def Survey_Get_Responses_Zapier(  )
		args = {'key' => @key, 'method' => 'Survey_Get_Responses_Zapier'}

		data = self.makeCall( args )
	    
		return data
	end                
	def Survey_Add_Tag( surveyId, tagId )
		args = {'key' => @key, 'method' => 'Survey_Add_Tag'}
		args['surveyId'] = surveyId
		args['tagId'] = tagId

		data = self.makeCall( args )
	    
		return data
	end                
	def Survey_Remove_Tag( surveyId, tagId )
		args = {'key' => @key, 'method' => 'Survey_Remove_Tag'}
		args['surveyId'] = surveyId
		args['tagId'] = tagId

		data = self.makeCall( args )
	    
		return data
	end                
	def Tag_Create( name )
		args = {'key' => @key, 'method' => 'Tag_Create'}
		args['name'] = name

		data = self.makeCall( args )
	    
		return data
	end                
	def Tag_Update( tagId, updateParameters )
		args = {'key' => @key, 'method' => 'Tag_Update'}
		args['tagId'] = tagId
		args['updateParameters'] = updateParameters

		data = self.makeCall( args )
	    
		return data
	end                
	def Tag_Delete( tagId )
		args = {'key' => @key, 'method' => 'Tag_Delete'}
		args['tagId'] = tagId

		data = self.makeCall( args )
	    
		return data
	end                
	def Tag_List( optionalParameters = {} )
		args = {'key' => @key, 'method' => 'Tag_List'}
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
	    
		return data
	end
	
	def flattenArray( name, arg )
        out = {}
        arg.length.times do |i|
            if arg[i].kind_of?( Hash )
                m = self.flattenHash( name+"[#{i}]", arg[i] )
                out.merge!(m)
            elsif arg[i].kind_of?( Array )
                m = self.flattenArray( name+"[#{i}]", arg[i] )
                out.merge!(m)
            else
                out[name+"[#{i}]"] = arg[i]
            end
        end

        return out
    end

    def flattenHash( name, arg )
        out = {}
        arg.each { |key, value|
            if value.kind_of?( Hash )
                m = self.flattenHash( name+"[#{key}]", value )
                out.merge!(m)
            elsif value.kind_of?( Array )
                m = self.flattenArray( name+"[#{key}]", value )
                out.merge!(m)
            else
                out[name+"["+key+"]"] = value
            end
        }

        return out
    end

	def flattenArgs( args )
		new_args = args.dup
		args.each { |key, value|
			if value.kind_of?( Hash )
				m = self.flattenHash( key, value )
				new_args.delete( key )
				new_args.merge!(m)
			elsif value.kind_of?( Array )
				m = self.flattenArray( key, value )
				new_args.delete( key )
				new_args.merge!(m)
			end
		}
		return new_args
    end

    def is_a_number?(s)
        return s.to_s.match(/\A[+-]?\d+?(\.\d+)?\Z/) == nil ? false : true
    end
	
	def makeCall( args )
        url = URI.parse( @api_url )
        args = self.flattenArgs( args )
        res = Net::HTTP.post_form( url, args )
        r = res.body.gsub(/"/, '')
        if self.is_a_number?(r)
			out = r.to_i
		elsif %w(true false).include?(res.body.to_s)
			out = res.body == "true"
		else
			unless res.body =~ /^\{.*\}$/
			r = "{\"value\":#{res.body}}"
			else
			r = res.body
			end
			
			out = JSON.parse r
			if ( ! out.kind_of?( Hash ) )
				return {} #Could not fetch API data
			end
			
			if ( out["result"] && out["result"] == "error" )
				raise "API Error: "+out["message"]+" ("+out["code"].to_s+")"
			end
		end
		return out
    end
end
		
class SurveyTownReseller < SurveyTown
	                
	def Admin_Create_Account( clientName, adminEmail, userName, password, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'Admin_Create_Account'}
		args['clientName'] = clientName
		args['adminEmail'] = adminEmail
		args['userName'] = userName
		args['password'] = password
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
	    
		return data
	end                
	def Admin_Get_Accounts(  )
		args = {'key' => @key, 'method' => 'Admin_Get_Accounts'}

		data = self.makeCall( args )
	    
		return data
	end                
	def Admin_Find_Accounts( optionalParameters = {} )
		args = {'key' => @key, 'method' => 'Admin_Find_Accounts'}
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
	    
		return data
	end                
	def Admin_Update_Account( clientId, optionalParameters )
		args = {'key' => @key, 'method' => 'Admin_Update_Account'}
		args['clientId'] = clientId
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
	    
		return data
	end                
	def Admin_Suspend_Account( clientId )
		args = {'key' => @key, 'method' => 'Admin_Suspend_Account'}
		args['clientId'] = clientId

		data = self.makeCall( args )
	    
		return data
	end                
	def Admin_Reinstate_Account( clientId )
		args = {'key' => @key, 'method' => 'Admin_Reinstate_Account'}
		args['clientId'] = clientId

		data = self.makeCall( args )
	    
		return data
	end                
	def Admin_Create_Account_Key( clientId, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'Admin_Create_Account_Key'}
		args['clientId'] = clientId
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
	    
		return data
	end                
	def Admin_Get_Account_Key( clientId, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'Admin_Get_Account_Key'}
		args['clientId'] = clientId
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
	    
		return data
	end                
	def Admin_Send_Message( clientIds, shortMessage, optionalParameters = {} )
		args = {'key' => @key, 'method' => 'Admin_Send_Message'}
		args['clientIds'] = clientIds
		args['shortMessage'] = shortMessage
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
	    
		return data
	end                
	def Admin_Get_Account_Webhooks( clientId )
		args = {'key' => @key, 'method' => 'Admin_Get_Account_Webhooks'}
		args['clientId'] = clientId

		data = self.makeCall( args )
	    
		return data
	end                
	def Admin_Set_Account_Webhooks( clientId, url, webhooksKey, hooks, locations, customFieldIds = [], optionalParameters = [] )
		args = {'key' => @key, 'method' => 'Admin_Set_Account_Webhooks'}
		args['clientId'] = clientId
		args['url'] = url
		args['webhooksKey'] = webhooksKey
		args['hooks'] = hooks
		args['locations'] = locations
		args['customFieldIds'] = customFieldIds
		args['optionalParameters'] = optionalParameters

		data = self.makeCall( args )
	    
		return data
	end                
	def Admin_Deactivate_Account_Webhooks( clientId )
		args = {'key' => @key, 'method' => 'Admin_Deactivate_Account_Webhooks'}
		args['clientId'] = clientId

		data = self.makeCall( args )
	    
		return data
	end
end